﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FastifyParameterParser = void 0;
const common_1 = require("@kitajs/common");
const nodes_1 = require("../util/nodes");
class FastifyParameterParser {
    supports(param) {
        const typeName = (0, nodes_1.getTypeNodeName)(param);
        switch (typeName) {
            case 'FastifyRequest':
            case 'FastifyReply':
            case 'FastifyInstance':
                return true;
            default:
                return false;
        }
    }
    parse(param, _route) {
        const typeName = (0, nodes_1.getTypeNodeName)(param);
        switch (typeName) {
            case 'FastifyRequest':
                return {
                    name: FastifyParameterParser.name,
                    value: common_1.kRequestParam
                };
            case 'FastifyReply':
                return {
                    name: FastifyParameterParser.name,
                    value: common_1.kReplyParam
                };
            case 'FastifyInstance':
                return {
                    name: FastifyParameterParser.name,
                    value: common_1.kFastifyParam
                };
            default:
                throw new Error(`Unknown Fastify parameter type: ${typeName}`);
        }
    }
}
exports.FastifyParameterParser = FastifyParameterParser;
//# sourceMappingURL=fastify.js.map