﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeaderParameterParser = void 0;
const common_1 = require("@kitajs/common");
const helpers_1 = require("../schema/helpers");
const nodes_1 = require("../util/nodes");
const syntax_1 = require("../util/syntax");
class HeaderParameterParser {
    config;
    constructor(config) {
        this.config = config;
    }
    supports(param) {
        return (0, nodes_1.getTypeNodeName)(param) === 'Header';
    }
    parse(param, route) {
        const name = (0, nodes_1.getParameterName)(param, 0);
        const optional = (0, nodes_1.isParamOptional)(param);
        (0, helpers_1.mergeSchema)(route, {
            headers: {
                type: 'object',
                properties: { [name]: { type: 'string' } },
                required: optional ? [] : [name],
                additionalProperties: this.config.generatorConfig.additionalProperties
            }
        });
        return {
            name: HeaderParameterParser.name,
            value: (0, syntax_1.buildAccessProperty)(common_1.kRequestParam, 'headers', name.toLowerCase())
        };
    }
}
exports.HeaderParameterParser = HeaderParameterParser;
//# sourceMappingURL=header.js.map