﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildRouteParser = void 0;
const chain_1 = require("./chain");
const html_1 = require("./html");
const rest_1 = require("./rest");
function buildRouteParser(config, schema, paramParser, typeChecker, collector) {
    const chain = new chain_1.ChainRouteParser();
    config.routeParserAugmentor?.(chain);
    chain
        .add(new html_1.HtmlRouteParser(config, paramParser, typeChecker, schema))
        .add(new rest_1.RestRouteParser(config, schema, paramParser, typeChecker, collector));
    return chain;
}
exports.buildRouteParser = buildRouteParser;
//# sourceMappingURL=index.js.map