﻿import type { JsonSchema, KitaConfig } from '@kitajs/common';
import type { ts } from 'ts-json-schema-generator';
import { BaseType, Schema } from 'ts-json-schema-generator';
export declare class SchemaBuilder {
    private config;
    /** All definitions read from this schema builder */
    private definitions;
    private parser;
    private formatter;
    constructor(config: KitaConfig, program: ts.Program);
    /** Creates a schema for the given ts node */
    createTypeSchema(node: ts.Node): BaseType;
    /** Saves and returns a {@linkcode ts.Node}'s respective json schema. */
    consumeNodeSchema(node: ts.TypeNode | BaseType, overrideName?: string): Schema;
    /**
     * Attempts to unwrap possible type wrappers and resolve into a primitive typescript base type.
     *
     * @param skipWrappers If we should return OptionalType or AnnotatedType wrappers or its inner type
     */
    toPrimitive(type: ts.Node | BaseType, skipWrappers?: boolean): BaseType | undefined;
    /** Get definition for a base type without the `#/definitions/` prefix. */
    formatDefinition(type: BaseType): Schema;
    /** Get all definitions as an array. */
    toSchemaArray(): JsonSchema[];
    /** Get the number of definitions. */
    getDefinitionCount(): number;
    /** Get the definition for a type name */
    getDefinition(name: string): JsonSchema | undefined;
    /** Appends new definitions to the schema builder. */
    appendChildDefinitions(type: BaseType, inner?: string): void;
}
//# sourceMappingURL=builder.d.ts.map