﻿import type { Route, RouteSchema } from '@kitajs/common';
import { type TypeFormatter } from 'ts-json-schema-generator';
/** Combines a route schema with a new schema. */
export declare function mergeSchema(route: Route, schema: Partial<RouteSchema>): void;
/**
 * Creates a type formatter that removes the `#/definitions/` prefix from `$ref` properties.
 *
 * This was a proposed option in ts-json-schema-generator, buy ruled out as out of scope.
 *
 * @see https://github.com/vega/ts-json-schema-generator/pull/1386
 */
export declare function removeFormatterDefinitions(typeFormatter: TypeFormatter): TypeFormatter;
/**
 * This is a workaround to move the response definition field to the end of the object.
 *
 * It's necessary for when the response references another definition that was not defined yet.
 *
 * Which throws a reference error at runtime because the referenced def was going to be defined after the response
 * definition
 */
export declare function correctFormatterChildrenOrder(typeFormatter: TypeFormatter): TypeFormatter;
//# sourceMappingURL=helpers.d.ts.map