﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultOpenApiInfo = exports.ScalarUiTheme = void 0;
const tslib_1 = require("tslib");
const node_fs_1 = tslib_1.__importDefault(require("node:fs"));
const node_path_1 = tslib_1.__importDefault(require("node:path"));
let version = '0.0.0';
try {
    version = require('../../package.json').version;
}
catch {
    // Ignore when version could not be found
}
/**
 * This theme was generously provided by the Scalar team to be used in our Scalar UI.
 *
 * Go give them a shout out at:
 *
 * @link https://twitter.com/scalar
 * @link https://scalar.com
 */
exports.ScalarUiTheme = node_fs_1.default
    .readFileSync(node_path_1.default.resolve(__dirname, '../../assets/swagger.css'), 'utf-8')
    // Simple minification step to reduce the size of the theme
    .trim()
    .replace(/\n/g, '')
    .replace(/\s+/g, ' ')
    .replace(/\/\*.*?\*\//g, '')
    .replace(/; /g, ';');
exports.DefaultOpenApiInfo = {
    title: 'API Reference',
    description: 'Powered by [Scalar](https://scalar.com/) & Generated by [KitaJS](https://kita.js.org/)',
    version
};
//# sourceMappingURL=swagger.js.map