﻿"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.joinParameters = exports.unquote = exports.buildAccessProperty = exports.VALID_IDENTIFIER = void 0;
const codegen_1 = require("./codegen");
exports.VALID_IDENTIFIER = /^[a-zA-Z_$][a-zA-Z_$0-9]*$/;
/** Builds a property access string from a list of names. */
function buildAccessProperty(...names) {
    let expr = '';
    for (const name of names) {
        if (name.match(exports.VALID_IDENTIFIER)) {
            if (expr) {
                expr += '.';
            }
            expr += name;
        }
        else {
            expr += `[${JSON.stringify(name)}]`;
        }
    }
    return expr;
}
exports.buildAccessProperty = buildAccessProperty;
/** Removes quotes from a string. */
function unquote(str) {
    return str.replace(/^['"`]|['"`]$/g, '');
}
exports.unquote = unquote;
function joinParameters(parameters) {
    return (0, codegen_1.join)(parameters, (p) => `
     ${p.helper};

     if (reply.sent) {
       return;
     }
    `, (p) => !!p.helper);
}
exports.joinParameters = joinParameters;
//# sourceMappingURL=syntax.js.map