﻿import { Parameter, ParameterParser, Parser, Route } from '@kitajs/common';
import { ts } from 'ts-json-schema-generator';
/** Traverse each statement of a source file for the given path and yields the result of the provided parser or an error. */
export declare function traverseStatements<R>(program: Pick<ts.Program, 'getSourceFile'>, parser: Parser<ts.Statement, R, []>, files: string[]): AsyncGenerator<Error | {
    parsed: R;
    statement: ts.Statement;
}, void, unknown>;
/** Traverse each source file for the given path and yields the result of the provided parser or an error. */
export declare function traverseProviders<R>(program: Pick<ts.Program, 'getSourceFile'>, parser: Parser<ts.SourceFile, R, []>, files: string[]): AsyncGenerator<Error | Awaited<R>, void, undefined>;
/**
 * Traverse each parameter for the given function and yields the result of the provided parser. Errors are thrown
 * synchronously.
 */
export declare function traverseParameters(fn: ts.FunctionDeclaration, parser: ParameterParser, route: Route | null): AsyncGenerator<{
    param: Parameter;
    index: number;
}, void, unknown>;
//# sourceMappingURL=traverser.d.ts.map